' ########################################################################################
' Microsoft Windows
' File: SimpleRibbon
' Contents: DDT dialog with a ribbon
' Compilers: PBWIN 10+, PBCC 6+
' Headers: Windows API headers 2.03+
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
#Compile Exe
#Dim All
%UNICODE = 1

' // Include files for external files
#Include  Once "CWindow.inc"   ' // CWindow class
#Include Once "UIRibbon.inc"
#Resource Res "SimpleRibbon.res"

' ========================================================================================
' Custom implementations of the IUIApplication and IUICommandHandler interfaces.
' ========================================================================================
Class CApplication As Com

   ' =====================================================================================
   Interface IUIApplicationImpl $IID_IUIApplication : Inherit IUnknown
   ' =====================================================================================

   Method OnViewChanged(ByVal viewId As Dword, ByVal typeID As Long, ByVal view As IUnknown, ByVal verb As Long, ByVal uReasonCode As Long) As Long
      Method = %E_NotImpl
   End Method

   Method OnCreateUICommand(ByVal commandId As Dword, ByVal typeID As Long, ByRef pCommandHandler As IUICommandHandler) As Long
      pCommandHandler = Me
      Method = %S_Ok
   End Method

   Method OnDestroyUICommand(ByVal commandId As Dword, ByVal typeID As Long, ByRef pCommandHandler As IUICommandHandler) As Long
      Method = %E_NotImpl
   End Method

   End Interface
   ' =====================================================================================

   ' =====================================================================================
   Interface IUICommandHandlerImpl $IID_IUICommandHandler : Inherit IUnknown
   ' =====================================================================================

   Method Execute (ByVal commandId As Dword, ByVal verb As Long, ByRef key As PROPERTYKEY, ByRef currentValue As PROPVARIANT, ByVal pCommandExecutionProperties As IUISimplePropertySet) As Long
      ?  "Command identifier:" & Str$(commandiD)
      Method = %S_Ok
   End Method

   Method UpdateProperty (ByVal commandId As Dword, ByRef key As PROPERTYKEY, ByRef currentValue As PROPVARIANT, ByRef newValue As PROPVARIANT) As Long
      Method = %E_NotImpl
   End Method

   End Interface
   ' =====================================================================================

End Class
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
Function PBMain

   Local hDlg As Dword

   ' // Create the dialog
   Dialog New Pixels, 0, "Simple Ribbon", , , 500, 320, %WS_Overlapped Or %WS_ThickFrame Or %WS_SysMenu Or _
   %WS_MinimizeBox Or %WS_MaximizeBox Or %WS_Visible Or %DS_Center To hDlg

   ' =====================================================================================
   ' // Initialize tne ribbon
   ' =====================================================================================

   ' // Create an instance of our host class
   Local pApplication As IUIApplicationImpl
   pApplication = Class "CApplication"
   If IsNothing(pApplication) Then Exit Function

   ' // Create an instance of the IUIFramework interface
   Local pFramework As IUIFramework
   pFramework = NewCom ClsId $CLSID_UIRibbonFramework
   If IsNothing(pFramework) Then Exit Function

   ' // Connects the host application to the Windows Ribbon framework.
   Local hr As Long
   hr = pFramework.Initialize(hDlg, pApplication)
   If hr <> %S_Ok Then Exit Function
   ' // Specifies the application modes to enable.
   hr = pFramework.SetModes(1)
   ' // Loads the Ribbon framework UI resource, or compiled markup, file.
   hr = pFramework.LoadUI(Exe.Inst, "APPLICATION_RIBBON")
   ' =====================================================================================

   ' // Display and activate the dialog
   Dialog Show Modal hDlg, Call DlgProc

End Function
' ========================================================================================

' ========================================================================================
' Main Dialog procedure
' ========================================================================================
CallBack Function DlgProc() As Long

   Select Case CbMsg

      Case %WM_Command
         Select Case Cb.Ctl
            ' ...
            ' ...
         End Select

   End Select

End Function
' =
